(**********************************************************************
*                                                                     *
*                    ணࠬ  Demo-ਬ                   *
*                                                                     *
**********************************************************************)
{$F+}
{$I Include.pas}
uses  {TRAP_00,}
      Objects, Drivers, Views, Menus, TextView, Dialogs, App,
      MsgBox, StdDlg,  Validate,
      Figaro, FigaroTV, FigaroIO, FigaroDg,
      WinProcs, SysTabl, Commands,
      Demo_Un1, Demo_Un2, Demo_Un3, About, Maker;

type

  PMyApp  = ^TMyApp;
  TMyApp  = object(TAppFigaro)
       HzViewPtr1,
       HzViewPtr2   : PHzView;
       HeapViewPtr  : PHeapView;
       ClockViewPtr : PClockView;
     constructor Init;
     procedure   HandleEvent(var E: TEvent);  virtual;
     procedure   HandleIO  (var E: TEvent);  virtual;
     procedure   HandleDlg (var E: TEvent);  virtual;
     procedure   InitMenuBar;  virtual;
     procedure   Idle ; virtual;
     function    StartDialog: boolean; virtual;
     procedure   MakeSysWindow;
  end;
{
       ķ
                               TMyApp                           
       Ľ
}
procedure Process_HeapView; far; forward;

constructor TMyApp.Init;
var  R :TRect;
     S :string;
begin
   if not inherited  Init then Fail;
   GetExtent (R);
   with R do begin
     A.X:=B.X-9;  B.Y:=A.Y+1;
   end;
   New(ClockViewPtr, Init(R));
   Insert (ClockViewPtr);

   GetExtent (R);
   with R do begin
     A.X:=B.X-19;  A.Y:=B.Y-1;
   end;
   case  Figaro.Get_Mode of
      rgPseudo    : s:=' Pseudo:';
      rgRealTime  : s:=' Real:';
      rgForceReal : s:=' Force:';
   end;
   HzViewPtr1:= New(PHzView, Init(R, S));
   Insert (HzViewPtr1);

   R.Move(-19, 0);
   HzViewPtr2:= New(PHzView, Init(R,' Scan: '));
   Insert (HzViewPtr2);

   with R do begin
     B.X:=A.X; A.X:=B.X-27;
   end;
   HeapViewPtr := New(PHeapView, Init(R));
   Insert (HeapViewPtr);

   Insert_Process (New(PProcess, Init('Heap View', true,
                   110, 0, 0, Stack(2000),
                   @Process_HeapView, HeapViewPtr)));

    MakeSysWindow;
end;
{}

procedure  TMyApp.MakeSysWindow;
var R : TRect;
begin
   GetExtent(R);   R.Grow(0,-2);
   R.A.X:=R.B.X-70;  R.A.Y:=R.B.Y div 2 - 3;
   Disable_Interrupt;
   if  SysTabl.SystemWindow<>nil
       then SysTabl.SystemWindow^.Select
       else InsertWindow (New(PWinSysTable, Init(R)));
   Enable_Interrupt;
end;
{}

procedure TMyApp.HandleIO  (var E: TEvent);
begin
 FigaroIO.ServerIO(E);
 inherited HandleIO (E);
end;

procedure TMyApp.HandleDlg  (var E: TEvent);
begin
 FigaroDg.ServerDlg (E);
 inherited HandleDlg (E);
end;

procedure TMyApp.Idle;
begin
   inherited Idle;
   if _StartDialog  then  exit;
   HzViewPtr1^.Update(Get_TimerFreq);
   HzViewPtr2^.Update(Get_IntrFreq);
   ClockViewPtr^.Update;
end;
{}

procedure TMyApp.InitMenuBar;
var  R:TRect;
begin
GetExtent (R);
R.B.Y:=R.A.Y+1;
MenuBar:=New (PMenuBar,Init(R,NewMenu(
  NewSubMenu('~P~rocess', 0, NewMenu(
    NewItem('~1~ Terminal priory 200','Shift-F1',
                                            kbShiftF1, cmTerm200, 0,
    NewItem('~2~ Terminal priory random', 'Shift-F2', kbShiftF2,
                                            cmTermRandom, 0,
    NewLine(
    NewItem('~3~ Text copy','Shift-F5',     kbShiftF3, cmTextCopy, 0,
    NewItem('~4~ Stream copy','Shift-F7',   kbShiftF4, cmStreamCopy, 0,
    NewLine(
    NewItem('~5~ System table', 'Shift-F5', kbShiftF5, cmSysTable, 0,
    NewItem('~6~ About', '', 0, cmAbout, 0,
     nil))))))))),
  NewSubMenu('~A~ctions', 0, NewMenu(
    NewItem('~1~ Lock',     '', 0, cmLock, 0,
    NewItem('~2~ Unlock',   '', 0, cmUnlock, 0,
    NewLine(
    NewItem('~3~ Suspend on 15 s', '', 0, cmSuspend, 0,
    NewItem('~4~ Resume',          '', 0, cmResume, 0,
    NewLine(
    NewItem('~5~ Stop',     '', 0, cmStop, 0,
    NewItem('~6~ Restart',  '', 0, cmRestart, 0,
    NewItem('~7~ Delete',   '', 0, cmDelete, 0,
    NewLine(
    NewItem('~X~ Exit',     'Alt+X', 0, cmQuit, 0,
     nil)))))))))))),
  NewSubMenu('~W~indow', 0, NewMenu(
    StdWindowMenuItems(nil)), nil))))));
end;
{}

procedure TMyApp.HandleEvent (var E: TEvent);

procedure  DoClose (p: PView); far;
begin
  if    (SizeOf(p^)= SizeOf(TWinProcess))
     or (SizeOf(p^)= SizeOf(TWinTerminal))
     or (SizeOf(p^)= SizeOf(TWinAbout))
     or (SizeOf(p^)= SizeOf(TProgress))
     then  begin
            Disable_Interrupt;
            PWindow(p)^.Close;
            Enable_Interrupt;
           end;
end;

var R : TRect;
begin
  inherited HandleEvent (E);
  if (E.What and evCommand) <> 0 then begin
   case E.Command of
     cmTerm200    : MakeTerminal_200;
     cmTermRandom : MakeTerminal_Random;
     cmTermBad    : MakeTerminal_Bad;
     cmSysTable   : MakeSysWindow;
     cmRotate     : MakeRotate;
     cmSender     : MakeSender;
     cmReciever   : MakeReceiver;
     cmTextCopy   : MakeTextCopy;
     cmStreamCopy : MakeStreamCopy;
     cmAbout      : MakeAbout;
     cmMaker      : Make_Maker;
     cmCloseAll   : DeskTop^.ForEach(@DoClose);
   end; {case}
   ClearEvent (E);
  end;
end;
{}
function   TMyApp.StartDialog : boolean;
begin
  _Regime:= Figaro.rgRealTime; { rgPseudo }
  _Freq  := 100; { Hz }
  StartDialog:= true;
end;
{}
procedure Process_HeapView;
var  p : PHeapView;
begin
  Pause(CSecond div 3);
  p:= PHeapView(Get_MyParamPtr);
  repeat
    if Assigned(p) then p^.Update;
    Pause(CSecond div 4 + random(CSecond div 4));
  until false;
end;
{}

var   MyApp   : TMyApp;

begin
   Randomize;
   if MyApp.Init then  MyApp.Run;
   MyApp.Done;
   {TRAP_00.Done;}
end.
