(**********************************************************************
*                                                                     *
*      ࣠   筮 । Turbo_Vision         *
*                                                                     *
**********************************************************************)
{$O-}
                            unit  FigaroDg;
                               interface

uses  Objects, Views, Drivers, MsgBox, StdDlg, App,
      Figaro, FigaroTV, Commands;

function  InProcess_MessageBox(const msg: String; Options: word): word;

function  InProcess_Question (S:string):boolean;

function  InProcess_FileDialog (WildCard: PString;
                             const Title, Name : string;
                             Options   : word;
                             HistoryId : byte ): word;

procedure  ServerDlg (E : TEvent);

{}
                             implementation
{}
type
   TFileDlgRec     = record
                      _Process : PString;
                      _Ident   : longint;
                      _Status  : word;
                      _WildCard: PString;
                      _Title   : PString;
                      _Name    : PString;
                      _Options : word;
                      _History : byte;
                    end;
{}
procedure  AppPutEvent (var E : TEvent);
begin
  repeat
    FigaroApp^.PutEvent (E);
    if E.What=0 then exit;
    Wait;
  until false;
end;

function PutEventToApp(var E:TEvent; Quit:longint): integer;
var     msg : PMsg;
        err : word;
begin
  E.What := evDialog;
  AppPutEvent(E);
  msg:= Get_Quit (Quit, -1, err);
  PutEventToApp:= integer(msg^._DataPtr);
  msg^._DataPtr:=nil;
  Delete_Msg(msg);
end;

procedure  SendQuit (const Process : string;
                             Ident : longint;
                             Data  : pointer);
var  msg : PMsg;
begin
    New (msg, Init (Data, false, true));
    msg^._Ident:=Ident;
    Send_Msg (Process, 0, msg);
end;
{}
function  InProcess_FileDialog (WildCard: PString;
                             const Title, Name : string;
                             Options   : word;
                             HistoryId : byte ): word;
var  Dat : TFileDlgRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process := PProcess(Get_MyPtr)^._NamePtr;
    _Ident   := Quit;
    _WildCard:= WildCard;
    _Title   := @Title;
    _Name    := @Name;
    _Options := Options;
    _History := HistoryId;
  end;
  with E do begin
    Command:= pmFileDialog;
    InfoPtr:= @Dat;
  end;
  InProcess_FileDialog:= word ( PutEventToApp(E, Quit) );
end;

procedure DoFileDialog(var E: TEvent);
var
    FileName : string;
    dlg : PFileDialog;
    res : word;
begin
   with TFileDlgRec(E.InfoPtr^) do begin
     FileName := _WildCard^;
     New(dlg, Init(_WildCard^, _Title^, _Name^, _Options, _History));
     res:=Application^.ExecuteDialog(dlg, _WildCard);
     SendQuit (_Process^, _Ident, pointer(res));
   end;
   E.What:=0
end;
{}

function  InProcess_MessageBox(const msg: String; Options: word): word;

var  Dat : TFileDlgRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr;
    _Ident  := Quit;
    _Name   := @msg;
    _Options:= Options;
  end;
  with E do begin
    Command:= pmMessageBox;
    InfoPtr:= @Dat;
  end;
  InProcess_MessageBox:= word ( PutEventToApp(E, Quit) );
end;

procedure DoMessageBox (var E: TEvent);
var  res : word;
begin
   with TFileDlgRec(E.InfoPtr^) do begin
     res:= MessageBox (_Name^, nil, _Options);
     SendQuit (_Process^, _Ident, pointer(res));
   end;
   E.What:=0
end;
{}

function InProcess_Question (S:string):boolean;
begin
   InProcess_Question:=
   InProcess_MessageBox (S, mfYesButton + mfNoButton) = cmYes;
end;

{}

procedure  ServerDlg (E : TEvent);
begin
  case E.Command of
   pmFileDialog  : DoFileDialog(E);
   pmMessageBox  : DoMessageBox(E);
   else exit;
  end;
  E.What:=0;
end;

end.
