(**********************************************************************
*                                                                     *
*        楤 䠩 -뢮  筮 ।       *
*                                                                     *
**********************************************************************)
{$O-}
                            unit  FigaroIO;
                               interface

uses  Dos, Crt, Objects, Drivers, StdDlg, App,
      Figaro, FigaroTV, Commands;

type  PPBufStream = ^PBufStream;

function  InProcess_Reset   (var F : Text): word;
function  InProcess_Rewrite (var F : Text): word;
function  InProcess_Readln  (var F : Text; S : PString): word;
function  InProcess_Writeln (var F : Text; S : PString): word;
function  InProcess_Close   (var F : Text): word;

function  InProcess_StreamInit (Stream  : PPBufStream;
                                const Name : string;
                                Options : word;
                                BufSize : word) : word;
function  InProcess_StreamRead (Stream: PStream;
                                Buf : pointer; Count : word): word;
function  InProcess_StreamWrite(Stream: PStream;
                                Buf : pointer; Count : word): word;
function  InProcess_StreamSeek (Stream: PStream; Pos : word): word;
function  InProcess_StreamClose(Stream: PPBufStream): word;


procedure  ServerIO  (var E : TEvent);
{}
                             implementation
{}

type

   TFileOperRec    = record
                      _Process : String;
                      _File    : ^Text;
                      _Ident   : longint;
                      _Status  : word;
                    end;

   TTextOperRec    = record
                      _Process : String;
                      _File    : ^Text;
                      _Ident   : longint;
                      _Status  : word;
                      _Result  : PString;
                    end;

   TStreamOperRec   = record
                      _Process : String;
                      _Stream  : Pointer;
                      _Result  : Pointer;
                      _Count   : word;
                      _Ident   : longint;
                      _Status  : word;
                    end;
{}
                        { 뢠   }

procedure  AppPutEvent (var E : TEvent);
begin
  repeat
    FigaroApp^.PutEvent (E);
    if E.What<>0  then Wait;
  until E.What=0;
end;

{}
                        { 뢠   }

function PutEventToApp(var E:TEvent; Quit:longint): integer;
var     msg : PMsg;
        err : word;
begin
  E.What := evIO;
  Disable_Interrupt;
  AppPutEvent(E);
  msg:= Get_Quit (Quit, 2*CSecond, err);
  if Assigned(msg)
     then begin
            PutEventToApp:= integer(msg^._DataPtr);
            Delete_Msg (msg);
          end
      else  PutEventToApp:= -1;
  Enable_Interrupt;
end;

{}
                { 뢠  䮭 ணࠬ }

procedure  SendQuit (const Process : string;
                             Ident : longint;
                             Data  : pointer);
var  msg : PMsg;
begin
     asm
        PUSHF
        CLI
     end;
    msg:= New (PMsg, Init (Data, false, true));
    asm  POPF  end;
    if Assigned(msg) then begin
       msg^._Ident:=Ident;
       Send_Msg (Process, 0, msg);
    end;
end;
{}

function  InProcess_Reset (var F : Text): word;
var  Dat : TFileOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _File := @F;
    _Ident:= Quit;
  end;
  with E do begin
    Command:= pmFileReset;
    InfoPtr:= @Dat;
  end;
  InProcess_Reset:= word ( PutEventToApp(E, Quit) );
end;

procedure DoFileReset (var E: TEvent);
begin
   with TFileOperRec(E.InfoPtr^) do begin
        {$I-}
        Reset (_File^);
        {$I+}
        SendQuit (_Process, _Ident, pointer(IOResult));
   end;
   E.What:=0
end;
{}

function  InProcess_Rewrite (var F : Text): word;
var  Dat : TFileOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _File := @F;
    _Ident:= Quit;
  end;
  with E do begin
    Command:= pmFileRewrite;
    InfoPtr:= @Dat;
  end;
  InProcess_Rewrite:= word ( PutEventToApp(E, Quit) );
end;

procedure DoFileRewrite(var E: TEvent);
begin
   with TFileOperRec(E.InfoPtr^) do begin
        {$I-}
        Rewrite (_File^);
        {$I+}
        SendQuit (_Process, _Ident, pointer(IOResult));
   end;
   E.What:=0
end;
{}

function  InProcess_Readln (var F : Text; S : PString): word;
var  Dat : TTextOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _File:= @F;
    _Ident:=Quit;
    _Result:=S;
  end;
  with E do begin
    Command:= pmReadln;
    InfoPtr:= @Dat;
  end;
  InProcess_Readln:= word ( PutEventToApp(E, Quit) );
end;

procedure DoReadln(var E: TEvent);
begin
   with TTextOperRec(E.InfoPtr^) do begin
        {$I-}
        Readln (_File^, _Result^);
        {$I+}
        SendQuit (_Process, _Ident, pointer(IOResult));
   end;
   E.What:=0
end;
{}

function  InProcess_Writeln (var F : Text; S : PString): word;
var  Dat : TTextOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _File:= @F;
    _Ident:=Quit;
    _Result:=S;
  end;
  with E do begin
    Command:= pmWriteln;
    InfoPtr:= @Dat;
  end;
  InProcess_Writeln:= word ( PutEventToApp(E, Quit) );
end;

procedure DoWriteln(var E: TEvent);
begin
   with TTextOperRec(E.InfoPtr^) do begin
        {$I-}
        Writeln (_File^, _Result^);
        {$I+}
        SendQuit (_Process, _Ident, pointer(IOResult));
   end;
   E.What:=0
end;
{}

function  InProcess_Close (var F : Text): word;
var  Dat : TFileOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _File:= @F;
    _Ident:=Quit;
  end;
  with E do begin
    Command:= pmFileClose;
    InfoPtr:= @Dat;
  end;
  InProcess_Close:= word ( PutEventToApp(E, Quit) );
end;

procedure DoFileClose(var E: TEvent);
begin
   with TFileOperRec(E.InfoPtr^) do begin
        {$I-}
        Close (_File^);
        {$I+}
        SendQuit (_Process, _Ident, pointer(IOResult));
   end;
   E.What:=0
end;
{}
function  InProcess_StreamInit (Stream : PPBufStream;
                                const Name : string;
                                Options : word;
                                BufSize : word) : word;
var  Dat : TStreamOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _Stream := pointer (Stream);
    _Result := @Name;
    _Count  := BufSize;
    _Status := Options;
    _Ident  := Quit;
  end;
  with E do begin
    Command:= pmStreamInit;
    InfoPtr:= @Dat;
  end;
  InProcess_StreamInit:= word ( PutEventToApp(E, Quit) );
end;

procedure DoStreamInit (var E: TEvent);
var  p : PBufStream;
begin
   with TStreamOperRec(E.InfoPtr^) do begin
     p:= New(PBufStream, Init(PString(_Result)^,_Status,_Count));
     PBufStream(_Stream^):=p;
     SendQuit (_Process, _Ident, pointer(p^.Status));
   end;
   E.What:=0
end;
{}

function  InProcess_StreamRead (Stream : PStream;
                                Buf : pointer; Count : word): word;
var  Dat : TStreamOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _Stream := pointer (Stream);
    _Result := Buf;
    _Count  := Count;
    _Ident  := Quit;
  end;
  with E do begin
    Command:= pmStreamRead;
    InfoPtr:= @Dat;
  end;
  InProcess_StreamRead:= word ( PutEventToApp(E, Quit) );
end;

procedure DoStreamRead (var E: TEvent);
begin
 with TStreamOperRec(E.InfoPtr^) do
   if Assigned(PStream(_Stream))  then
    begin
     PStream(_Stream)^.Read (_Result^,_Count);
     SendQuit (_Process,_Ident,pointer(PStream(_Stream)^.Status));
    end
    else SendQuit (_Process,_Ident,pointer(0));
 E.What:=0
end;
{}

function  InProcess_StreamWrite (Stream : PStream;
                                 Buf : pointer; Count : word): word;
var  Dat : TStreamOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _Stream := pointer (Stream);
    _Result := Buf;
    _Count  := Count;
    _Ident  := Quit;
  end;
  with E do begin
    Command:= pmStreamWrite;
    InfoPtr:= @Dat;
  end;
  InProcess_StreamWrite:= word ( PutEventToApp(E, Quit) );
end;

procedure DoStreamWrite (var E: TEvent);
begin
 with TStreamOperRec(E.InfoPtr^) do
   if Assigned(PStream(_Stream))  then
    begin
     PStream(_Stream)^.Write (_Result^,_Count);
     SendQuit (_Process, _Ident, pointer(PStream(_Stream)^.Status));
    end
    else SendQuit (_Process, _Ident, pointer(0));
 E.What:=0
end;
{}

function  InProcess_StreamSeek (Stream: PStream; Pos : word): word;
var  Dat : TStreamOperRec;
       E : TEvent;
     err : word;
    Quit : longint;
begin
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _Stream := pointer (Stream);
    _Count  := Pos;
    _Ident  := Quit;
  end;
  with E do begin
    Command:= pmStreamSeek;
    InfoPtr:= @Dat;
  end;
  InProcess_StreamSeek:= word ( PutEventToApp(E, Quit) );
end;

procedure DoStreamSeek (var E: TEvent);
begin
 with TStreamOperRec(E.InfoPtr^) do
   if Assigned(PStream(_Stream))  then
    begin
      PStream(_Stream)^.Seek (_Count);
      SendQuit (_Process, _Ident, pointer(PStream(_Stream)^.Status));
    end
    else SendQuit (_Process, _Ident, pointer(0));
 E.What:=0
end;
{}
function  InProcess_StreamClose (Stream : PPBufStream): word;

var  Dat : TStreamOperRec;
       E : TEvent;
    Quit : longint;
begin
  InProcess_StreamClose:=OK;
  Quit:=Get_TimeFromStart;
  with Dat do begin
    _Process:= PProcess(Get_MyPtr)^._NamePtr^;
    _Stream := pointer (Stream);
    _Ident  := Quit;
    if pointer(_Stream^)=nil then exit;
  end;
  with E do begin
    Command:= pmStreamClose;
    InfoPtr:= @Dat;
  end;
  InProcess_StreamClose:= word ( PutEventToApp(E, Quit) );
end;

procedure DoStreamClose (var E: TEvent);
var  p : PBufStream;
begin
   with TStreamOperRec(E.InfoPtr^) do begin
     p:= PBufStream(_Stream^);
     if Assigned(p) then Dispose (p, Done);
     pointer(_Stream^):=nil;
     SendQuit (_Process, _Ident, pointer(0));
   end;
   E.What:=0
end;
{}
                  { 뢠  䮭 ணࠬ }

procedure  ServerIO (var E : TEvent);
begin
  Disable_Interrupt;
  case E.Command of
   pmFileReset   : DoFileReset(E);
   pmFileRewrite : DoFileRewrite(E);
   pmReadln      : DoReadln(E);
   pmWriteln     : DoWriteln(E);
   pmFileClose   : DoFileClose(E);

   pmStreamInit  : DoStreamInit(E);
   pmStreamRead  : DoStreamRead(E);
   pmStreamWrite : DoStreamWrite(E);
   pmStreamSeek  : DoStreamSeek(E);
   pmStreamClose : DoStreamClose(E);
  end;
  Enable_Interrupt;
  E.What:=0;
end;

end.
